//const _old_window_battleLog_displayHpDamage = Window_BattleLog.prototype.displayHpDamage
Window_BattleLog.prototype.displayHpDamage = function(target, item) {
  let result = target.result();
  if(result.isHit() && (result.hpDamage > 0 || (result.mpDamage > 0 && result.hpDamage == 0))) {
    if(!!result.elementStrong) {
      this.push("addText","...It was a moving attack!");
      this.push("waitForNewLine");
    }
    else if(!!result.elementWeak) {
	  this.push("addText", "...It was a dull attack.");
      this.push("waitForNewLine")
    }
  }
  return _old_window_battleLog_displayHpDamage.call(this, target)
};

// Make the SEH emotion lock states count as happy/sad/angry
Game_Battler.prototype.isEmotionAffected = function (type, noCustom = false) {
    let Space_Ex_Boyfriend_Angry = this.isStateAffected(119) || this.isStateAffected(120) || this.isStateAffected(121);
    let Sweetheart_Happy = this.isStateAffected(197) || this.isStateAffected(122) || this.isStateAffected(123);
    let Unbread_Twins_Sad = this.isStateAffected(124) || this.isStateAffected(125) || this.isStateAffected(126);
    let Enemy_Angry = this.isStateAffected(248) || this.isStateAffected(249) || this.isStateAffected(250);
    let Enemy_Happy = this.isStateAffected(251) || this.isStateAffected(252) || this.isStateAffected(253);
    let Enemy_Sad = this.isStateAffected(254) || this.isStateAffected(255) || this.isStateAffected(256);
    if (!!noCustom) {
        Space_Ex_Boyfriend_Angry = false;
        Sweetheart_Happy = false;
        Unbread_Twins_Sad = false;
        Enemy_Angry = false;
        Enemy_Happy = false;
        Enemy_Sad = false;
    }
    switch (type.toLowerCase()) {
        case "happy":
            return this.isStateAffected(6) || this.isStateAffected(7) || this.isStateAffected(8) || Sweetheart_Happy || Enemy_Happy;
        case "sad":
            return this.isStateAffected(10) || this.isStateAffected(11) || this.isStateAffected(12) || Unbread_Twins_Sad || Enemy_Sad;
        case "angry":
            return this.isStateAffected(14) || this.isStateAffected(15) || this.isStateAffected(16) || Space_Ex_Boyfriend_Angry || Enemy_Angry;
        case "afraid":
            return this.isStateAffected(18);
    }
}

Game_Action.prototype.calcElementRate = function(target) {
        // YIN Instead of bypassing the subject's attack element, we want to use it if they are inflicted with an emotion.
        // If elementId == None or Normal Attack
        if (this.item().damage.elementId < 1) {
            // These are all base emotion states (non afraid)
            var emotionStates = [6, 7, 8, 10, 11, 12, 14, 15, 16];
            emotionStates = [...emotionStates, 119,120,121]; // Boss angry
            emotionStates = [...emotionStates, 122,123,197]; // Boss happy
            emotionStates = [...emotionStates, 124, 125, 126]; // Boss sad
            emotionStates = [...emotionStates, 248, 249, 250, 251, 252, 253, 254, 255, 256]; // Enemy emotions
            // Search states for emotion states
            var emotionAfflicted;

            this.subject()._states.forEach(function(stateId) {
                // Do we have an emotion state on us?
                if (emotionStates.contains(stateId)) {
                    emotionAfflicted = true;
                }
            }, this);
            if (emotionAfflicted) {
                return target.elementRate(this.subject().attackElements()[0]); // If so, that is our attack element
            } else {
                return target.elementRate(this.item().damage.elementId);
            }
        } else {
        return target.elementRate(this.item().damage.elementId);
        }
};

Game_BattlerBase.prototype.paramMin = function(paramId) {
  return 1;
};